;Simple ZX Spectrum 48K speech synthesizer
;by utz 08'13
;in: bc - address of text to speak
;uses/destroys: af,af',bc,hl



speak	ld a,#0d		;revert potential code modification
	ld (_sval),a
	
_next	;ei
	ld a,(bc)		;load character code
	or a			;if it is 0, end of message reached
	ret z
	
	push bc			;preserve msg pointer
	ld hl,_table		;point to jump table
	cp 97
	jr nc,_ofs
	
	ld (_sval),a
	jr _skip
	
_ofs	sub 97			;subtract ascii offset
	add a,a			;calculate table offset
	ld c,a
	xor a
	ld b,a
	add hl,bc		;add offset to table pointer
	ld c,(hl)		;load sample address to bc
	inc hl
	ld b,(hl)
	push bc
	pop hl			;put sample address in hl
	;di
	call _rdata		;output speech
	
_skip	pop bc			;restore & increase msg pointer
	inc bc
	jr _next

_rdata	ex af,af'
	ld b,(hl)		;read sample data
	xor a
	cp b
	jr z,_pdone		;if it is 0, end of sample reached
	
	ex af,af'
	
	out (#fe),a

_waitlp	push hl
_sval EQU $+1
	ld l,#0d		;self-modifying speed adjustment
_ilp	dec l
	jr nz,_ilp
	
	pop hl
	djnz _waitlp
	
	inc hl
	xor #10			;a=0 on entry, because it's cleared after @ofs
	jr _rdata


_pdone	ex af,af'
	ret
	

_table	dw _aa,_bb,_cc,_dd,_ee,_ff,_gg,_hh,_ii,_jj,_kk,_ll,_mm,_nn,_oo,_pp,_qq,_rrr,_ss,_tt,_uu,_vv,_ww,_xx,_yy,_zz,_gap	

_aa
include "a.asm"
	db 0
_bb
include "b.asm"
	db 0
_cc
include "c.asm"
	db 0
_dd
include "d.asm"
	db 0
_ee
include "e.asm"
	db 0
_ff
include "f.asm"
	db 0
_gg
include "g.asm"
	db 0
_hh
include "h.asm"
	db 0
_ii
include "i.asm"
	db 0
_jj
include "j.asm"
	db 0
_kk
	db 255
include "k.asm"
	db 0
_ll
include "l.asm"
	db 0
_mm
include "m.asm"
	db 0
_nn
include "n.asm"
	db 0
_oo
include "o.asm"
	db 0
_pp
include "p.asm"
	db 255,0
_qq
include "q.asm"
	db 0
_rrr
include "r.asm"
	db 0
_ss
include "s.asm"
	db 255,0
_tt
include "t.asm"
	db 255,0
_uu
include "u.asm"
	db 0
_vv
include "v.asm"
	db 0
_ww
include "w.asm"
	db 0
_xx
include "x.asm"
	db 0
_yy
include "y.asm"
	db 0
_zz
include "z.asm"
	db 0
_gap
	db 255,255,255,0

end